// Add new pages
function addPages() {
    if (window.AppsgeyserJSInterface) {
        for (var i in pages_l) {
            var page = pages_l[i];
            AppsgeyserJSInterface.addToHomePage(page.name, page.url);
        }
    }
    getPages();
}
// Get pages
function getPages() {
    if (window.AppsgeyserJSInterface) {
        var itemsString = AppsgeyserJSInterface.getHomePageItems(), items;
        if (itemsString) {
            try {
                items = JSON.parse(itemsString);
            } catch (e) {
            }
        }
        if (items && items.length > 0) {
            pages = items;
        } else {
            addPages();
        }
    }
}

function randomColor() {
    var number = Math.floor((Math.random() * 17) + 0);
    return number;
}

// Get favicon site
function getIconForUrl(url) {
    var iconSrc = '',
        url_parser = new URI(url),
        ic = {
            'facebook': 'facebook-icon.png',
            'www.google.com': 'google-search-icon.png',
            'twitter': 'twitter-icon.png',
            'youtube': 'youtube-icon.png',
            'vimeo': 'vimeo-icon.png',
            'apple': 'apple-icon.png',
            'instagram': 'instagram-icon.png',
            'drive.google': 'google-drive-icon.png',
            'plus.google': 'google-plus-icon.png',
            'www.tumblr.com': 'tumblr-icon.png',
            'yahoo': 'yahoo-icon.png',
            'github.com': 'github-icon.png',
            'dribbble.com': 'dribbble-icon.png',
            'behance.net': 'behance-icon.png',
            'www.bebo.com': 'bebo-icon.png',
            'mail.google': 'google-mail-icon.png',
            'reddit': 'reddit-icon.png',
            'pinterest': 'pinterest-icon.png',
            'aliexpress.com': 'aliexpress.png',
            'amazon.com': 'amazon.png',
            'aol.com': 'AOL.png',
            'asknetwork': 'ask_network.png',
            'booking.com': 'booking.png',
            'cbsinteractive.com': 'CBSInter.png',
            'cnn.com': 'CNN.png',
            'drom.ru': 'DROM.png',
            'ebay.com': 'ebay.png',
            'foxnews.com': 'foxnews2.png',
            'imdb.com': 'imdb-icon.png',
            'mode.com': 'ModeMedia.png',
            'nbc.com': 'NBSUniversal.png',
            'nytimes.com': 'newyorktimes.png',
            'vk.com': 'VK.png',
            'weather.com': 'weathercompany.png',
            'wikimediafoundation.org': 'wikimediafoundation.png',
            'microsoft.com': 'windows.png',
            'yelp.com': 'Yelp.png',
            'linkedin.com': 'linkedin.png'
        }, icon = null;

    $.each(ic, function (i, v) {
        if (url_parser.hostname().indexOf(i) !== -1)icon = v;
    })
    return icon;
}


// Show pages
function showPages() {
    var $template = $('.template .tiles'), html, $contents = $('.contents'), $page3 = $('#page3');
    $contents.empty();
    $page3.empty();
    if (!window.AppsgeyserJSInterface) {
        pages = pages_l;
    }
    $.each(pages, function (i, v) {
        html = '<div class="col s3 l3 m3" style="max-height: 117px;" db-id="' + v.id + '"><div class="tiles center" href="' + v.url + '"><div class="tile_inside" >';
        if (pages_l.length > i) {
            if (pages_l[i].icon == '' || pages_l[i].icon == undefined) {
                pages_l[i].icon = getIconForUrl(v.url);
                if (pages_l[i].icon == null) {
                    color = randomColor();
                    html += '<img style="max-height: 96px;"  src="custom-' + color + '.png"><div class="name-img">' + v.name.charAt(0) + '</div>';
                } else {
                    html += '<img style="max-height: 96px;"  src="' + pages_l[i].icon + '">';
                }
            } else {
                html += '<img style="max-height: 96px;"  src="./' + pages_l[i].icon + '">';
            }
        } else {
            color = randomColor();
            html += '<img style="max-height: 96px;"  src="custom-' + color + '.png"><div class="name-img">' + v.name.charAt(0) + '</div>';
        }


        html += '<div class="name noselect">' + v.name + '</div></div></div></div>';
        if (i < 7) {
            $contents.append(html);
            $page3.append(html);
        } else {
            $page3.append(html);
        }
    });
    $contents.append('<div class="col s3 l3 m3" style="max-height: 117px;"><div class="center"><div class="modal-add" href="#modal-add"><img style="max-height: 96px;" src="add-page.png"><div class="name noselect">Add page</div></div></div></div>');
}


function loadWeather(location, woeid) {
    var $weather = $(".weather");
    $.simpleWeather({
        location: location,
        woeid: woeid,
        unit: 'f',
        success: function (weather) {
            localStorage.setItem('region',weather.region);

            html = '<div style="width: 100%;overflow: hidden;" id="wea" data-hr="' + weather.link + '">' +
                '<img class="col s6 m5 s4 valign center" style="margin: 0 auto;" src="' + weather.image + '">' +
                '<h5 class="col s4 m6 s4 valign center ">' + weather.alt.temp + '&deg;C / ' + weather.temp + '&deg;' + weather.units.temp + '' +
                '<i style="float: right;color: silver;margin-top: -6%; margin-right: 3%;margin-left: 3%;" id="settings-geo" class="material-icons">&#xE8B8;</i>' +
                '</h5>' +
                '<p class="col s12 m6 s4 valign center">' + location + ' ' + weather.region + '</p>' +
                '</div>';
            $weather.html(html);
            $weather.attr('href', weather.link);

        },
        error: function (error) {
            $weather.html('<p style="padding: 45px;" class="error-message">' + error.message + '</p><i style="float: right;color: silver;margin-top: -6%; margin-right: 3%; margin-left: 3%;" id="settings-geo" class="material-icons">&#xE8B8;</i>');
            $("#page1").html('<p style="padding: 25px;">' + error.message + '</p><i style="float: right;color: silver;margin-top: -6%; margin-right: 3%;margin-left: 3%;" id="settings-geo" class="material-icons">&#xE8B8;</i>');
        }
    });
}

function jfeedToGfeed(jFeed) {
    var response = {responseData: {}};
    response.responseData.feed = jFeed;
    console.log(jFeed);
    if (!jFeed.items) return response;
    response.responseData.feed.entries = jFeed.items;
    var entries = response.responseData.feed.entries;
    for (var i = 0; i < entries.length; i++) {
        entries[i].publishedDate = entries[i].updated;
        entries[i].contentSnippet = entries[i].description;
    }
    response.responseData.entries = entries;
    return response;
}

function google(url) {
    console.log(url);
    return $.ajax({
        url: url, cache: false, dataType: 'jsonp',
        success: function (data) {

            if ('AppsgeyserJSInterface' in window) {
                AppsgeyserJSInterface.setItem('lastPostTime', data.responseData.results[0]['publishedDate'].toString());
                var ONE_HOUR = 1000 * 60 * 60 * 6;

                if ('registerUpdateChecker' in AppsgeyserJSInterface) {
                    AppsgeyserJSInterface.registerUpdateChecker('checker.html', ONE_HOUR);
                }
            }

            var news = $('#news');
            var ul = '';
            console.log(data.responseData.results);
            $.each(data.responseData.results, function (i, v) {
                ul += '<li class="collection-item avatar z-depth-2 col m5 l3" href="' + v.unescapedUrl + '">';
                if (v.image !== undefined) {
                    img = '<img src="' + v.image.url + '" alt="" class="textImg">';
                    ul += '<div class="image">' + img + '</div><p>' + v.content + '</p>';
                } else {
                    ul += '<h6 style="margin: 20px;">' + v.title + '</h6><p>' + v.content + '</p>';
                }
                ul += '</li>';
                $(news).append(ul);
                ul = '';
            });
        },

        error: function (jxhr, e) {
        }
    });
}

function yahoo(country) {
    if (localStorage.getItem('region') !== 'RU') {
        return $.getFeed({
            url: 'http://news.yahoo.com/rss/world',
            success: function (data) {
                var it = jfeedToGfeed(data);
                var news = $('#news');
                var ul = '';
                $.each(it.responseData.entries, function (i, v) {
                    ul += '<li class="collection-item avatar z-depth-2 col m5 l3" href="' + v.link + '">';
                    if (v.image !== undefined) {
                        img = '<img src="' + v.image.url + '" alt="" class="textImg">';
                        ul += '<div class="image">' + img + '</div><p>' + v.description + '</p>';
                    } else {
                        ul += '<h6 style="margin: 20px;">' + v.title + '</h6><p>' + v.description + '</p>';
                    }
                    ul += '</li>';
                });
                $(news).append(ul);
            }
        });
    }
}

function loadNews(city, country) {
    console.log(country);
    if (city !== null && city !== '') {
        var google_url = "https://ajax.googleapis.com/ajax/services/search/news?v=1.0&q=" + city + "&hl="+$.trim(localStorage.getItem('region'))+"&rsz=8";

        $('#page1').append('<h3 class="center">Top stories</h3><i style="float: right;color: silver;" id="settings-news" class="material-icons set-news"></i>' +
            '<p id="not" style="margin-left:35px;"><input type="checkbox" class="filled-in" id="notifications"  checked="checked"/><label for="notifications">' +
            'News notifications</label></p><ul class="collection close-news row" id="news"></ul>');

        $.when(google(google_url), yahoo(country)).done(function (a1, a2) {
            var news = $('#news');
            news.imagesLoaded(function () {
                news.masonry({
                    itemSelector: '.collection-item'
                });
            });
        });

    }
}

// Return news and weather
function getContent() {
    $.getJSON("http://www.geoplugin.net/json.gp?jsoncallback=?",
        function (data) {
            //$.jStorage.deleteKey('city');
            console.log(data);
            var value = $.jStorage.get("city");
            if (data.geoplugin_region == null || data.geoplugin_region == '') {
                if (value == null || value == '') {
                    $('.weather').html('<div class="row" style="width:100%"><P class="flow-text">Select your city</P><div class="input-field col s12"><input placeholder="City" id="geo" type="text" class="validate">' +
                        '<button class="btn waves-effect waves-light" type="submit" name="action" id="add_geo" style="    text-transform: none;">Add</button>' +
                        '<button class="btn waves-effect waves-light" type="submit" name="action" id="cancel_geo" style="    text-transform: none;">Cancel</button>' +
                        '</div></div>');
                }
            }
            if (value !== null) {
                data.geoplugin_region = value;
                if ('AppsgeyserJSInterface' in window) {
                    AppsgeyserJSInterface.setItem('city', value);
                }
            }
            $('body').append('<div id="city_js" style="display: none;">' + data.geoplugin_region + '</div>');
            $.each(module, function (i, v) {
                if (v.ModuleWeather == '1') {
                    loadWeather(data.geoplugin_region, data.geoplugin_countryCode);
                } else if (v.ModuleWeather == '0') {
                    $('.weather').addClass('hide');
                }

                if (v.ModuleNews == '1') {
                    loadNews(data.geoplugin_region, data.geoplugin_countryCode);
                }
            });
        });
}


function fixScroll(height) {
    var heCl = height, id = $('.swiper-slide-active')[0].lastElementChild.id;
    if (id == '') {
        id = $('.swiper-slide-active')[0].id;
    }
    var o = document.getElementById(id);
    if (o.scrollHeight > heCl) {
        if (id == 'page2') {
            $('#' + id).css({overflowY: 'auto'});
        } else {
            $('#' + id).parent().css({overflowY: 'auto'});
        }
    }
}

function getHistory(obj) {

    var cart = [];
    var history = jQuery.parseJSON(obj);

    console.log(history);

    for (var i = 0; i < history.history.length; i++) {
        cart.push({date: history.history[i].date, url: history.history[i].url, title: history.history[i].title});
    }
    var arr = history.history.reverse();
    for (var a = 0; a < arr.length; a++) {
        if (arr[a] && a <= 30) {
            console.log(JSON.stringify(arr[a]));
            var h = new Date(arr[a].date);
            var time = h.getHours() + ':' + h.getMinutes();
            $('.history ul').append('<li class="collection-item his-'+arr[a]._id+'" >' +
                '<div class="truncate">' + time + ' <span style="margin-left: 10px; font-size:1em;font-weight: 100;color: #9E9E9E;">' + arr[a].title + '</span >' +
                '<a href="#!" class="secondary-content"><i class="material-icons history" data-id="'+arr[a]._id+'">delete</i></a>' +
                '</div></li>');
        }
    }
}

function deleteHistory(id){
    console.log(id)
}

$(document).ready(function () {
    $('.navbar').css({backgroundColor: colorBar});
    if (window.AppsgeyserJSInterface) {
        $('.navbar').remove();
    }
    if($('.history .collection li').length == 1) {
        $('.history').fadeOut();
    }
    getPages();
    showPages();
    getContent();
    if('AppsgeyserJSInterface' in window) {
        AppsgeyserJSInterface.getWeeklyHistory('getHistory');
    }
    $('#page2').parent().css({overflowY: 'auto'});

    var deleteWidth = $('.delete').offsetWidth;
    //var hammertime = $("body").hammer();
    //
    //hammertime.on('hold', '.tiles', function (e) {
    //    e.preventDefault();
    //    var $tile = $(this);
    //    $('.delete').remove();
    //
    //    $('<div class="delete"></div>').appendTo($tile);
    //
    //    $('.delete').hammer().on('tap', function (e) {
    //        e.stopImmediatePropagation();
    //        var index = $('.contents').children().index($tile),
    //            dd_id = $tile.parent().attr('db-id');
    //        if (window.AppsgeyserJSInterface) {
    //            AppsgeyserJSInterface.removeFromHomepage(dd_id);
    //        }
    //        $('.delete').remove();
    //        $tile.parent().remove();
    //    });
    //});

    $('.navbar').click(function () {
        alert('Some app functionality may not work in preview');
    });
    // enb\dis notifications
    $(document).on('click', '#notifications', function () {
        var value = $(this).prop("checked");
        if ('AppsgeyserJSInterface' in window) {
            AppsgeyserJSInterface.setItem('notifications', value);
        }
    });

    // ADD CITY
    $(document).on('click', '#add_geo', function () {
        var value = $('#geo').val();
        console.log(value);
        if (value !== '') {
            $.jStorage.set("city", value);
            location.reload();
        } else {
            alert('Pleas, enter your city !');
        }
    });
    // CANCEL CITY
    $(document).on('click', '#cancel_geo', function () {
        $('#geo_settings_modal').remove();
        $('#wea').show();
        $('.error-message').show();
    });

    // GO YAHOO
    $(document).on('click', '#wea', function () {
        var url = $(this).attr('data-hr');
        window.location.href = url;
    });

    // OPEN MODAL
    $(document).on('click', '.modal-add', function () {
        var $block = $('#modal-add');
        if ($block.hasClass('close')) {
            $block.addClass('open');
            $block.removeClass('close');
        }
    });

    // ADD PAGE
    $(document).on('click', '#add-page', function () {
        var $form = $('#page'), url = $('#url').val(), title = $('#name').val();
        if (window.AppsgeyserJSInterface) {
            AppsgeyserJSInterface.addToHomePage(title, url);
        }
        location.reload();
    });

    // CLOSE MODEL
    $(document).on('click', '.modal-close', function () {
        var $block = $('#modal-add');
        if ($block.hasClass('open')) {
            $block.removeClass('open');
            $block.addClass('close');
        }
    });
    $(document).on('click', '.material-icons.history', function () {
        if ('AppsgeyserJSInterface' in window) {
            $('.his-'+$(this).data('id')).remove();
            AppsgeyserJSInterface.removeHistoryItem($(this).data('id'), 'deleteHistory');
            if($('.history .collection li').length == 1) {
                $('.history').fadeOut();
            }
        }
    });

    // OPEN NEWS
    $(document).on('click', '#news > li', function () {
        var url = $(this).attr('href');
        window.location.href = url;
    });

    $(document).on('click', '.contents > div > div, #page3 > div > div', function () {
        var url = $(this).attr('href');
        if(url){
            window.location = url;
        }
    });

    // OPEN SETTING GEO
    $(document).on('click', '#settings-geo', function (e) {
        e.preventDefault();
        e.stopPropagation();
        $('#wea').hide();
        $('.error-message').hide();
        $('#geo_settings_modal').remove();
        $('.weather').append('<div class="row" id="geo_settings_modal" style="width:100%">' +
            '<P class="flow-text">Select your city</P><div class="input-field col s12">' +
            '<input placeholder="City" id="geo" type="text" class="validate"><button class="btn waves-effect waves-light" type="submit" name="action" id="add_geo" style="text-transform: none;">Add</button><button class="btn waves-effect waves-light" type="submit" name="action" id="cancel_geo" style="    text-transform: none;">Cancel</button></div></div>');
        $('#geo').val($('#city_js').html());
    });

    // OPEN SETTING NOTIFICATION
    $(document).on('click', '#settings-news', function () {
        $('#not').fadeIn();
        $(this).attr('id', 'settings-news-ds');
    });
    // CLOSE SETTING NOTIFICATION
    $(document).on('click', '#settings-news-ds', function () {
        $('#not').fadeOut();
        $(this).attr('id', 'settings-news');
    });

    $('head').append('' +
        '<style>' +
        '.btn, .btn-large {background-color: ' + colorBar + ';}' +
        '.btn:hover, .btn-large:hover {background-color: ' + colorBar + '; opacity: 0.6;}' +
        'input:not([type]):focus:not([readonly]), input[type=text]:focus:not([readonly]), input[type=password]:focus:not([readonly]), input[type=email]:focus:not([readonly]), input[type=url]:focus:not([readonly]), input[type=time]:focus:not([readonly]), input[type=date]:focus:not([readonly]), input[type=datetime-local]:focus:not([readonly]), input[type=tel]:focus:not([readonly]), input[type=number]:focus:not([readonly]), input[type=search]:focus:not([readonly]), textarea.materialize-textarea:focus:not([readonly]) ' +
        '{border-bottom: 1px solid ' + colorBar + '; opacity: 0.6;' +
        'box-shadow: 0 1px 0 0 ' + colorBar + ';' +
        '}' +
        '.history{color: ' + colorBar + ';}' +
        '</style>' +
        '');
});

window.onload = function () {
    $.each(module, function (i, v) {
        if (v.ModuleNews == 0) {
            $('#page1').parent().remove();
        }
    });
    var swiper = new Swiper('.swiper-container', {
        pagination: '.swiper-pagination',
        paginationClickable: true,
        paginationBulletRender: function (index, className) {
            return '<span class="' + className + '" style="background-color: #' + colorPaginationActive + ' !important"></span>';
        },
        spaceBetween: 10,
        calculateHeight: true,
        onSlideChangeEnd: function () {
            fixScroll(swiper.height);
        }
    });
    swiper.slideTo(1, 0);
    if ('AppsgeyserJSInterface' in window) {
        var notifications = AppsgeyserJSInterface.getItem('notifications');
        if (notifications !== 'false') {
            AppsgeyserJSInterface.setItem('notifications', true);
            $('#notifications').prop('checked', true);
        } else {
            AppsgeyserJSInterface.setItem('notifications', false);
            $('#notifications').prop('checked', false);
        }
    }
};